#include <stdio.h>
#include <openssl/rsa.h>
#include <openssl/evp.h>
#include <openssl/objects.h>
#include <openssl/x509.h>
#include <openssl/err.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>

#include "license-base.h"
#include "rsa.h"


char private_key[]="-----BEGIN RSA PRIVATE KEY-----\n\
MIICXAIBAAKBgQDHA2xRoXZqqVL9BX+BGWMx6c6lTXT8iQBekn6lcR1qR0BgaJqP\n\
SMejvNUUGwRvSgx11t/9UrrIWGlYj7HqD1P/il6cNzvWYxea6y4kHBdtZMykVox8\n\
AAuGG/KILS8psjR8GaFJ2wi6OeU2yFPSHTf+hWGRnYc/STW6uY7wS5gxpwIDAQAB\n\
AoGBALNfTXkB25ZlSSxOkU6N0E9DmgJ5ntCitteGmGmLW2TYFZkPjwdIJNBauX6m\n\
n0ejaTmo0zgjIcDDlyfAVC5PZHecpahXLO4hRp8QuwHTM7oVlrAR4yy8s5QQuBIv\n\
dqwbkmjC6aDyHvANQNLCIngmGaMD2SgMxqbz0AhE9Wwad4FRAkEA+RmlBh/mjIKT\n\
INJP+YCr/fWmBamgqXVRqjkX3UjBBoB8sgmce+UMgC6K1PdqV4AVfTgULQz6Ljqf\n\
a8/ciaG8uQJBAMyGnaQQpmhl1SbHdGXlgpff7VZoEMwvpwb+Ei1a4nqJdXe/ZNKv\n\
tgLU4iNDQj4Ur5aMOcY1RDt1lS2A30qx8V8CQBUkAgdlCbH/GvF8J+Fq9C3XfUGZ\n\
xdLb7BRgSBA1rnwYx3xsqGUzaT4vtQSiAtpuOmSoL74rDciCnSkPOQ5NNbECQFzj\n\
wtMR8NI3ddCQA/CHhYF+5Wc6Cm8CMYT+fbj1ryjiJ2TEm4EI5sxwbWiAkqRpdroU\n\
Y+T+qkerBp7NChz9plcCQFDHffQn6lCtZsxMBXTrNrjblrte883PapeK7DniFe3P\n\
xr+La04H+q1vWrvKCKSnXRRchVvXEkOchqODO87RoNk=\n\
-----END RSA PRIVATE KEY-----";

char cert_data[] = "-----BEGIN CERTIFICATE-----\n\
MIIC4DCCAkmgAwIBAgIJAObgCWhOvIa7MA0GCSqGSIb3DQEBBQUAMIGIMQswCQYD\n\
VQQGEwJDTjEQMA4GA1UECAwHQmVpamluZzEQMA4GA1UEBwwHQmVpamluZzENMAsG\n\
A1UECgwEQ1MyQzEPMA0GA1UECwwGU2VydmVyMRAwDgYDVQQDDAd3YW5nbGVpMSMw\n\
IQYJKoZIhvcNAQkBFhRsZWkud2FuZ0BjczJjLmNvbS5jbjAeFw0xMjAzMjEwMTUx\n\
MzNaFw0yMjAzMTkwMTUxMzNaMIGIMQswCQYDVQQGEwJDTjEQMA4GA1UECAwHQmVp\n\
amluZzEQMA4GA1UEBwwHQmVpamluZzENMAsGA1UECgwEQ1MyQzEPMA0GA1UECwwG\n\
U2VydmVyMRAwDgYDVQQDDAd3YW5nbGVpMSMwIQYJKoZIhvcNAQkBFhRsZWkud2Fu\n\
Z0BjczJjLmNvbS5jbjCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAxwNsUaF2\n\
aqlS/QV/gRljMenOpU10/IkAXpJ+pXEdakdAYGiaj0jHo7zVFBsEb0oMddbf/VK6\n\
yFhpWI+x6g9T/4penDc71mMXmusuJBwXbWTMpFaMfAALhhvyiC0vKbI0fBmhSdsI\n\
ujnlNshT0h03/oVhkZ2HP0k1urmO8EuYMacCAwEAAaNQME4wHQYDVR0OBBYEFBj6\n\
g6gQ6lqJpYDPe5xSxS29v0fcMB8GA1UdIwQYMBaAFBj6g6gQ6lqJpYDPe5xSxS29\n\
v0fcMAwGA1UdEwQFMAMBAf8wDQYJKoZIhvcNAQEFBQADgYEAV1vEflTkJNQ1lIN8\n\
vxlIqNHXYCCNsVGlIrpodmZ3rt8Oexe0hZKIo06mwcc/hM9XN9gtmgAh5ByLfniE\n\
e1Ybpn6FaSAR58Lpq51n+LZM+v61InsDzPb/w/VMjAN4L+kPHxGZrp27kHc2tNft\n\
oVffkyxkIo/cJbi9Zl8tQKjYA3s=\n\
-----END CERTIFICATE-----";

int rsa_sign(char *data,int dlen,char *sign,int *slen)
{
  int err = 0;
//  static char keyfile[]  = DEFAULT_RSA_PRIVATE_KEY;
  EVP_MD_CTX     md_ctx;
  EVP_PKEY *      pkey;
//  RSA		*rsa;
 // FILE *          fp;
  X509 *        x509;
  BIO 		*kbio;

  /* Just load the crypto library error strings,
   * SSL_load_error_strings() loads the crypto AND the SSL ones */
  /* SSL_load_error_strings();*/

  ERR_load_crypto_strings();
  /* Read private key */
/*
  fp = fopen (keyfile, "r");
  if (fp == NULL) {
	return CS2C_LICENSE_NO_PRIVATE_KEY;
  }

  pkey = PEM_read_PrivateKey(fp, NULL, NULL, NULL);
  fclose (fp);
*/


//  printf("%s\n",private_key);
  kbio = BIO_new_mem_buf((void*)private_key, -1);
  if(kbio==NULL)
  {
        ERR_print_errors_fp (stderr);
	return CS2C_LICENSE_OPENSSL_ERR;
  }
  pkey = PEM_read_bio_PrivateKey(kbio, NULL, 0,  NULL);
//  SSL_CTX_use_RSAPrivateKey(CTX, rsa);

  if (pkey == NULL) {
        ERR_print_errors_fp (stderr);
	BIO_free(kbio);
	return CS2C_LICENSE_OPENSSL_ERR;
  }

  /* Do the signature */

  EVP_MD_CTX_init(&md_ctx);
  EVP_SignInit   (&md_ctx, EVP_sha1());
  EVP_SignUpdate (&md_ctx, data, dlen);
  err = EVP_SignFinal (&md_ctx, sign, slen, pkey);
  EVP_MD_CTX_cleanup(&md_ctx);

  if (err != 1) {
        ERR_print_errors_fp(stderr);
	BIO_free(kbio);
	err = CS2C_LICENSE_OPENSSL_ERR;
  }

  EVP_PKEY_free (pkey);
  BIO_free(kbio);
  if(err == 1) err = 0;
  return err;
}



int rsa_verify(char *sign,int slen,char *verify,int vlen)
{

  int err;
  static char certfile[] = DEFAULT_RSA_CERT;
  EVP_MD_CTX     md_ctx;
  EVP_PKEY *     pkey;
  FILE *         fp = NULL;
  X509 *        x509 = NULL ;
  BIO 		*cbio = NULL;

  /* Read public key */
/*
  fp = fopen (certfile, "r");
  if (fp == NULL) 
	return CS2C_LICENSE_OPENSSL_ERR;

  x509 = PEM_read_X509(fp, NULL, NULL, NULL);
  fclose (fp);
*/

//  x509 = d2i_X509(NULL, &cert_data, strlen(cert_data));
  cbio = BIO_new_mem_buf((void*)cert_data, -1);
  if(cbio==NULL)
  {
        ERR_print_errors_fp (stderr);
        return CS2C_LICENSE_OPENSSL_ERR;
  }

  PEM_read_bio_X509(cbio, &x509, 0, NULL);
//  SSL_CTX_use_certificate(CTX, cert);

  if (x509 == NULL) {
        ERR_print_errors_fp (stderr);
	BIO_free(cbio);
	return CS2C_LICENSE_OPENSSL_ERR;
  }

  /* Get public key - eay */
  pkey=X509_get_pubkey(x509);
  if (pkey == NULL) {
        ERR_print_errors_fp (stderr);
	BIO_free(cbio);
  	X509_free(x509);
	return CS2C_LICENSE_OPENSSL_ERR;	
  }

  /* Verify the signature */

  EVP_VerifyInit   (&md_ctx, EVP_sha1());
  EVP_VerifyUpdate (&md_ctx, verify, vlen);
  err = EVP_VerifyFinal (&md_ctx, sign, slen, pkey);

  EVP_MD_CTX_cleanup(&md_ctx);

  EVP_PKEY_free (pkey);
  BIO_free(cbio);
  X509_free(x509);

  if (err != 1) {
        ERR_print_errors_fp (stderr);
	return CS2C_LICENSE_RSA_VERIFY_FAILED;
//        exit (1);
  }
//  printf ("Signature Verified Ok.\n");
  return 0;
}

